#include <stdio.h>


typedef struct fpu__reg {
  unsigned sigl;
  unsigned sigh;
  short exp;
} FPU_REG;


int FPU_u_mul(const FPU_REG *a, const FPU_REG *b, FPU_REG *c, unsigned int cw,
	      char sign, int expon);

#define PR_64_BITS 0x300
#define RC_RND 0x0000

#define FULL_PRECISION (PR_64_BITS | RC_RND | 0x3f)

int main()
{
  FPU_REG a = { 0x1b1b1b1b, 0xa3a3a3a3, 0 },
	  b = { 0x12345608, 0x87654321, 1 },
	  c;

  FPU_u_mul(&a, &b, &c, FULL_PRECISION, 0, 300);

  printf("%04x %08lx %08lx\n",
	 c.exp, c.sigh, c.sigl);

}


void FPU_exception(int n)
{

  printf("FPU_exception(%04x)\n", n);

}

void set_precision_flag_down() {}
void set_precision_flag_up() {}
void arith_overflow() {}
